package com.iconplus.smartproc.service.bidang;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.BidangRequest;
import com.iconplus.smartproc.repository.BidangRepository;
import org.springframework.stereotype.Service;

@Service
public class DeleteBidangService implements BaseService<BidangRequest, EmptyResponse> {

    private BidangRepository bidangRepository;

    public DeleteBidangService (BidangRepository bidangRepository) {
        this.bidangRepository = bidangRepository;
    }

    @Override
    public EmptyResponse execute(BidangRequest input) {

        var bidang = bidangRepository.findByIdAndIsDeleteFalse(input.getId()).orElseThrow(() -> new BusinessException("err", "err", "err"));

        bidang.setIsDelete(true);
        bidangRepository.save(bidang);

        return new EmptyResponse();
    }
}
