package com.iconplus.smartproc.service.instansi;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.InstansiRequest;
import com.iconplus.smartproc.model.response.InstansiResponse;
import com.iconplus.smartproc.repository.InstansiRepository;
import org.springframework.stereotype.Service;

@Service
public class PutUpdateInstansiService implements BaseService<InstansiRequest, InstansiResponse> {

    private InstansiRepository instansiRepository;

    public PutUpdateInstansiService(InstansiRepository instansiRepository) {
        this.instansiRepository = instansiRepository;
    }

    @Override
    public InstansiResponse execute(InstansiRequest input) {

        var instansi = instansiRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException("err", "err", "err"));

        instansi.setInstansi(input.getInstansi());
        instansi.setAlamat(input.getAlamat());
        instansi.setKeterangan(input.getKeterangan());
        instansi.setIsActive(input.getIsActive());
        var result = instansiRepository.save(instansi);

        return InstansiResponse.builder()
                .id(result.getId())
                .build();
    }
}
