package com.iconplus.smartproc.service.unitinisiator;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.UnitInisiatorRequest;
import com.iconplus.smartproc.model.response.UnitInisiatorResponse;
import com.iconplus.smartproc.repository.UnitInisiatorRepository;
import org.springframework.stereotype.Service;

@Service
public class PutUpdateUnitInisiatorService implements BaseService<UnitInisiatorRequest, UnitInisiatorResponse> {

    private UnitInisiatorRepository unitInisiatorRepository;

    private PutUpdateUnitInisiatorService(UnitInisiatorRepository unitInisiatorRepository) {
        this.unitInisiatorRepository = unitInisiatorRepository;
    }

    @Override
    public UnitInisiatorResponse execute(UnitInisiatorRequest input) {

        var unitInisiator = unitInisiatorRepository.findByIdAndIsDeleteFalse(input.getId()).orElseThrow(() -> new BusinessException("err", "err", "err"));
        unitInisiator.setUnitInisiator(input.getUnitInisiator());
        unitInisiator.setKeterangan(input.getKeterangan());
        unitInisiator.setIsActive(input.getIsActive());
        var result = unitInisiatorRepository.save(unitInisiator);

        return UnitInisiatorResponse.builder()
                .id(result.getId())
                .build();
    }
}
